/*
 * Copyright (c) 2008-2013 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global NX,Nexus,Sonatype,Ext*/
NX.define('Nexus.ssl.smtp.ShowSmtpCertificateButton', {
  extend : 'Ext.Button',
  mixins : ['Nexus.LogAwareMixin'],
  requires : ['Nexus.ssl.certificate.AddByServerFetch', 'Nexus.ssl.smtp.UseNexusTruststoreCheckbox'],
  xtype : 'show-smtp-certificate-button',

  host : '',
  port : 587,

  disabled : true,
  text : 'Show certificate',

  handler : function() {
    var self = this,
          cmp = Ext.create({
            xtype : 'ssl-add-by-server',
            host : self.host + ':' + self.port
          });

    cmp.asWindow('Show SMTP certificate').show();
    cmp.onLoad();
  },
  setState : function(settings){
    var button = this;
    button.setDisabled(!settings.sslEnabled);
    button.host = settings.host;
    button.port = settings.port;
  }
}, function() {
  Sonatype.Events.addListener('serverConfigViewPostInit', function(panel) {
    var form = panel.getForm(),
        // Panel#addButton only takes a button configuration, no instance
        button = panel.find('name', 'smtp-settings')[0].addButton({xtype:'show-smtp-certificate-button'});

    form.on('actioncomplete', function(form, action) {
      if (action.type !== 'sonatypeLoad') {
        return;
      }
      button.setState(action.result.data.smtpSettings);
    });

    form.findField('smtpSettings.sslEnabled').on('check', function(field, checked) {
      button.setDisabled(!checked);
    });
    form.findField('smtpSettings.host').on('change', function(field) {
      button.host = field.getValue();
    });
    form.findField('smtpSettings.port').on('change', function(field) {
      button.port = field.getValue();
    });

  });
});