/*
 * Copyright (c) 2008-2013 Sonatype, Inc.
 *
 * All rights reserved. Includes the third-party code listed at http://links.sonatype.com/products/nexus/pro/attributions
 * Sonatype and Sonatype Nexus are trademarks of Sonatype, Inc. Apache Maven is a trademark of the Apache Foundation.
 * M2Eclipse is a trademark of the Eclipse Foundation. All other trademarks are the property of their respective owners.
 */
/*global NX,define*/

define('nexus-staging-plugin-boot', [
    'Nexus/staging/repository/RepositoriesView',
    'Sonatype/repoServer/ProfileEditor',
    'Sonatype/repoServer/RulesetEditor',
    'Sonatype/repoServer/StagingPanel',
    'Sonatype/repoServer/StagingRuleSet',
    'Sonatype/repoServer/StagingUploadPanel'
], function() {
    NX.log.debug('Main nexus-staging-plugin modules loaded');
});

// FIXME: WARNING
// FIXME: Find a better place for this to live, still not sure what this is really doing!
// FIXME: WARNING

Sonatype.Events.addListener('privilegePanelInit', function (panel) {
    var profileStore = new Ext.data.JsonStore({
        url: Sonatype.config.servicePath + '/staging/profiles',
        root: 'data',
        id: 'id',

        fields: [
            { name: 'id' },
            { name: 'name', sortType: Ext.data.SortTypes.asUCString }
        ],

        sortInfo: {
            field: 'name',
            direction: 'asc'
        }
    });

    panel.profileStore = profileStore;
    panel.profileStore.load();

    var func = function (value, parent) {
        if (!Ext.isEmpty(value)) {
            // FIXME: What is 'this' here?
            return this.convertDataValue(value, this.profileStore, 'id', 'name');
        }
        return '';
    };

    panel.propertyTypeStore.add(new Ext.data.Record({
        'type': 'profile',
        'converter': func.createDelegate(panel)
    }));
});